/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package eb;
import java.sql.*;
import javax.ejb.*;
import javax.sql.DataSource;
import java.rmi.RemoteException;
import java.util.Enumeration;
import java.util.Vector;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */
public class AccountExplBean extends AccountBean {
  DataSource dataSource;

  public AccountBeanPK ejbCreate(int number, String customer, long balance)
          throws CreateException, RemoteException {
    super.ejbCreate(number, customer, balance);
    try {

      // First see if the object already exists
      ejbFindByPrimaryKey(new AccountBeanPK(number));

      // If so, then we have to throw an exception
      throw new DuplicateKeyException("Primary key already exists");
    } catch (ObjectNotFoundException e) {

      // Otherwise we can go ahead and create it...
    }
    Connection        connection = null;
    PreparedStatement statement = null;

    try {
      connection = dataSource.getConnection();
      statement =
        connection.prepareStatement("INSERT INTO accountsample (accno, customer, balance) VALUES (?, ?, ?)");
      statement.setInt(1, number);
      statement.setString(2, customer);
      statement.setLong(3, balance);
      if (statement.executeUpdate() != 1) {
        throw new CreateException("Error adding row");
      }
      return new AccountBeanPK(number);
    } catch (SQLException e) {
      throw new EJBException("Error executing SQL INSERT INTO accountsample (accno, customer, balance) VALUES (?, ?, ?): "
                             + e.toString());
    }
    finally {
      closeConnection(connection, statement);
    }
  }

  public AccountBeanPK ejbCreate(int number)
          throws CreateException, RemoteException {
    return ejbCreate(number, null, 0);
  }

  public void ejbRemove() throws RemoveException, RemoteException {
    super.ejbRemove();
    Connection        connection = null;
    PreparedStatement statement = null;

    try {
      connection = dataSource.getConnection();
      statement =
        connection.prepareStatement("DELETE FROM accountsample WHERE accno = ?");
      statement.setInt(1, number);
      if (statement.executeUpdate() < 1) {
        throw new RemoveException("Error deleting row");
      }
    } catch (SQLException e) {
      throw new EJBException("Error executing SQL DELETE FROM accountsample WHERE accno = ?: "
                             + e.toString());
    }
    finally {
      closeConnection(connection, statement);
    }
  }

  public void ejbLoad() throws RemoteException {
    AccountBeanPK key = (AccountBeanPK) entityContext.getPrimaryKey();

    number = key.number;
    Connection        connection = null;
    PreparedStatement statement = null;

    try {
      connection = dataSource.getConnection();
      statement =
        connection.prepareStatement("SELECT customer, balance FROM accountsample WHERE accno = ?");
      statement.setInt(1, number);
      ResultSet resultSet = statement.executeQuery();

      if (!resultSet.next()) {
        throw new NoSuchEntityException("Row does not exist");
      }
      this.customer = resultSet.getString(1);
      this.balance = resultSet.getLong(2);
    } catch (SQLException e) {
      throw new EJBException("Error executing SQL SELECT customer, balance FROM accountsample WHERE accno = ?: "
                             + e.toString());
    }
    finally {
      closeConnection(connection, statement);
    }
    super.ejbLoad();
  }

  public void ejbStore() throws RemoteException {
    super.ejbStore();
    Connection        connection = null;
    PreparedStatement statement = null;

    try {
      connection = dataSource.getConnection();
      statement =
        connection.prepareStatement("UPDATE accountsample SET customer = ?, balance = ? WHERE accno = ?");
      statement.setString(1, customer);
      statement.setLong(2, balance);
      statement.setInt(3, number);
      if (statement.executeUpdate() < 1) {
        throw new NoSuchEntityException("Row does not exist");
      }
    } catch (SQLException e) {
      throw new EJBException("Error executing SQL UPDATE accountsample SET customer = ?, balance = ? WHERE accno = ?: "
                             + e.toString());
    }
    finally {
      closeConnection(connection, statement);
    }
  }

  public AccountBeanPK ejbFindByPrimaryKey(AccountBeanPK accountKey)
          throws ObjectNotFoundException {
    Connection        connection = null;
    PreparedStatement statement = null;

    try {
      connection = dataSource.getConnection();
      statement =
        connection.prepareStatement("SELECT accno FROM accountsample WHERE accno = ?");
      statement.setInt(1, accountKey.number);
      ResultSet resultSet = statement.executeQuery();

      if (!resultSet.next()) {
        throw new ObjectNotFoundException("Primary key does not exist");
      }
      return accountKey;
    } catch (SQLException e) {
      throw new EJBException("Error executing SQL SELECT accno FROM accountsample WHERE accno = ?: "
                             + e.toString());
    }
    finally {
      closeConnection(connection, statement);
    }
  }

  // changed from Collection to Enumeration
  public Enumeration ejbFindAllAccounts() throws FinderException  {
    Connection        connection = null;
    PreparedStatement statement = null;

    try {
      connection = dataSource.getConnection();
      statement =
        connection.prepareStatement("SELECT accno FROM accountsample");
      ResultSet resultSet = statement.executeQuery();
      Vector    keys = new Vector();

      while (resultSet.next()) {
        int number = resultSet.getInt(1);

        keys.addElement(new AccountBeanPK(number));
      }
      return keys.elements();
    } catch (SQLException e) {
      throw new EJBException("Error executing SQL SELECT accno FROM accountsample: "
                             + e.toString());
    }
    finally {
      closeConnection(connection, statement);
    }
  }

  void closeConnection(Connection connection, Statement statement) {
    try {
      if (statement != null) {
        statement.close();
      }
    } catch (SQLException e) {}
    try {
      if (connection != null) {
        connection.close();
      }
    } catch (SQLException e) {}
  }

  public void setEntityContext(EntityContext entityContext)
          throws RemoteException {
    super.setEntityContext(entityContext);
    try {
      javax.naming.Context context = new javax.naming.InitialContext();

      try {
        dataSource =
          (DataSource) context.lookup("java:comp/env/jdbc/AccountDB");
      } catch (Exception e) {
        throw new EJBException("Error looking up dataSource: "
                               + e.toString());
      }
    } catch (Exception e) {
      throw new EJBException("Error initializing context:" + e.toString());
    }
  }

  public void unsetEntityContext() throws RemoteException {
    super.unsetEntityContext();
    this.entityContext = null;
  }

  // not generated
  public AccountBeanPK ejbFindByNumber(int accno)
          throws ObjectNotFoundException, FinderException {
    return ejbFindByPrimaryKey(new AccountBeanPK(accno));
  }

}
