package sb;

import java.rmi.*;
import javax.ejb.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class OpBean implements SessionBean, SessionSynchronization {
  private SessionContext sessionContext;

  // added
  protected int total = 0;	// actual state of the bean
  protected int newtotal = 0;	// value inside Tx, not yet committed.
  protected String clientUser = null;

  // modified
  public void ejbCreate(String user) {
    total = 0;
    clientUser = user;
  }
  public void ejbRemove() throws RemoteException {
  }
  public void ejbActivate() throws RemoteException {
  }
  public void ejbPassivate() throws RemoteException {
  }
  public void setSessionContext(SessionContext sessionContext) throws RemoteException {
    this.sessionContext = sessionContext;
  }
  // modified
  public void afterBegin() {
    newtotal = total;
  }
  public void beforeCompletion() {
  }

  // modified
  public void afterCompletion(boolean committed) {
    if (committed) {
      total = newtotal;
    }
  }

  /*========================= Op implementation ============================*/

  /**
   * Business method implementation.
   * @param s  nb of shares to be bought
   */
  public void buy(int s) {
    newtotal = newtotal + s;
    return;
  }

  /**
   * Business method implementation.
   * @return  the nb of shares bought
   */
  public int read() {
    return newtotal;
  }

  /**
    * return the name of the principal name returned by getCallerPrincipal
    */
  public String getPrincipalName() {
    return sessionContext.getCallerPrincipal().getName();
  }

}